## net.i2p.data.i2np
Class DatabaseLookupMessage

    java.lang.Object
      net.i2p.data.DataStructureImpl
          net.i2p.data.i2np.I2NPMessageImpl
              net.i2p.data.i2np.DatabaseLookupMessage

All Implemented Interfaces:
  DataStructure, I2NPMessage

    public class DatabaseLookupMessage

extends I2NPMessageImpl

Defines the message a router sends to another router to search for a key in the network database.

Author:
  jrandom

Nested Class Summary

Nested classes/interfaces inherited from class net.i2p.data.i2np.I2NPMessageImpl
`I2NPMessageImpl.Builder`

Field Summary
`static int` `MESSAGE_TYPE`

Fields inherited from class net.i2p.data.i2np.I2NPMessageImpl
`_context, CHECKSUM_LENGTH, DEFAULT_EXPIRATION_MS`

Fields inherited from interface net.i2p.data.i2np.I2NPMessage
`MAX_ID_VALUE, MAX_SIZE`

Constructor Summary
`DatabaseLookupMessage(I2PAppContext context)`
`DatabaseLookupMessage(I2PAppContext context, boolean locallyCreated)`

Method Summary
`protected int` `calculateWrittenLength()` calculate the message body's length (not including the header and footer
`boolean` `equals(java.lang.Object object)`
`java.util.Set` `getDontIncludePeers()` Set of peers that a lookup reply should NOT include
`Hash` `getFrom()` Contains the router who requested this lookup
`TunnelId` `getReplyTunnel()` Contains the tunnel ID a reply should be sent to
`Hash` `getSearchKey()` Defines the key being searched for
`int` `getType()` Return the unique identifier for this type of I2NP message, as defined in the I2NP spec
`int` `hashCode()`
`void` `readMessage(byte[] data, int offset, int dataSize, int type)` Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification
`void` `setDontIncludePeers(java.util.Set peers)`
`void` `setFrom(Hash from)`
`void` `setReplyTunnel(TunnelId replyTunnel)`
`void` `setSearchKey(Hash key)`
`java.lang.String` `toString()`
`protected int` `writeMessageBody(byte[] out, int curIndex)` write the message body to the output array, starting at the given index.

Methods inherited from class net.i2p.data.i2np.I2NPMessageImpl
`createMessage, fromRawByteArray, fromRawByteArray, getMessageExpiration, getMessageSize, getRawMessageSize, getUniqueId, read, readBytes, readBytes, readBytes, readMessage, registerBuilder, setMessageExpiration, setUniqueId, toByteArray, toByteArray, toRawByteArray, verifyUnwritten, writeBytes, written`

Methods inherited from class net.i2p.data.DataStructureImpl
`calculateHash, fromBase64, fromByteArray, read, toBase64`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface net.i2p.data.DataStructure
`calculateHash, fromBase64, fromByteArray, toBase64`

Field Detail

### MESSAGE_TYPE

    public static final int MESSAGE_TYPE

See Also:
  Constant Field Values

Constructor Detail

### DatabaseLookupMessage

    public DatabaseLookupMessage(I2PAppContext context)

### DatabaseLookupMessage

    public DatabaseLookupMessage(I2PAppContext context,
                                 boolean locallyCreated)

Method Detail

### getSearchKey

    public Hash getSearchKey()

  Defines the key being searched for

### setSearchKey

    public void setSearchKey(Hash key)

### getFrom

    public Hash getFrom()

  Contains the router who requested this lookup

### setFrom

    public void setFrom(Hash from)

### getReplyTunnel

    public TunnelId getReplyTunnel()

  Contains the tunnel ID a reply should be sent to

### setReplyTunnel

    public void setReplyTunnel(TunnelId replyTunnel)

### getDontIncludePeers

    public java.util.Set getDontIncludePeers()

  Set of peers that a lookup reply should NOT include

  Returns:
    Set of Hash objects, each of which is the H(routerIdentity) to skip

### setDontIncludePeers

    public void setDontIncludePeers(java.util.Set peers)

### readMessage

    public void readMessage(byte[] data,
                            int offset,
                            int dataSize,
                            int type)
                     throws I2NPMessageException,
                            java.io.IOException

  Description copied from interface: `I2NPMessage`
  Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification

  Parameters:
    `data` - data to read from
    `offset` - where to start in the data array
    `dataSize` - how long into the data to read
    `type` - I2NP message type
  Throws:
    `I2NPMessageException` - if the stream doesn't contain a valid message that this class can read.
    `java.io.IOException` - if there is a problem reading from the stream

### calculateWrittenLength

    protected int calculateWrittenLength()

  Description copied from class: `I2NPMessageImpl`
  calculate the message body's length (not including the header and footer

  Specified by:
    `calculateWrittenLength` in class `I2NPMessageImpl`

### writeMessageBody

    protected int writeMessageBody(byte[] out,
                                   int curIndex)
                            throws I2NPMessageException

  Description copied from class: `I2NPMessageImpl`
  write the message body to the output array, starting at the given index.

  Specified by:
    `writeMessageBody` in class `I2NPMessageImpl`
  Returns:
    the index into the array after the last byte written
  Throws:
    `I2NPMessageException`

### getType

    public int getType()

  Description copied from interface: `I2NPMessage`
  Return the unique identifier for this type of I2NP message, as defined in the I2NP spec

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `java.lang.Object`

### equals

    public boolean equals(java.lang.Object object)

  Overrides:
    `equals` in class `java.lang.Object`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`